#if (!defined(KBCL0_INCLUDED))

#define KBCL0_INCLUDED		1

#include <stdarg.h>
#include <new>

void kerrorExit(const char *f, ...);
void *kerrorExitP0(void *p, const char *f, ...);

void kqsort(void *base, int num, int size, void *cmp, void *opt);

int kpopCount32(unsigned int b);
int kpopCount64(unsigned long long b);
unsigned int kgetMsb32(unsigned int i);

struct KNoInit {
	int dummy;
};

struct KMemPool;
extern KMemPool *kmemPool;

//struct KPtrPool; // ͂KMemPool̎xNXƂĂ̗p݂̂z肵Ă.
//void *KPtrPool_dest(KPtrPool *p);
struct KPtrPool {
    int s;
    void *p, *opt;
	void *(*f)(int, void *);
    int a, u;
	KPtrPool(int s_, KMemPool *mp = kmemPool);	// Iɂ͑̃RXgN^邩Ȃ. ȂȂ.
	void free(void *q);
	void *alloc(); // KPtrPoolłNULLԂȂz.
	void *calloc();
	int inUseMem(int *pn = 0);
	static void *dest(KPtrPool *p);
};

//struct KSizPtr;
//void *KSizPtr_dest(KSizPtr *p);
struct KSizPtr {
	int s, s1;
	char *p;
	KMemPool *mp;
	inline KSizPtr(KNoInit *ni) { (void) ni; }
	KSizPtr(KMemPool *mp_ = kmemPool, int s1_ = 0);
	KSizPtr *reset(int s1_ = 0);
	KSizPtr *reserve(int s0);
	void *reserve1(int s0);
	KSizPtr *expand2();
	KSizPtr *addChar(int c);
	KSizPtr *addInt(int i);
	KSizPtr *addPtr(void *p_);
	KSizPtr *addBytes(int s_, const char *p_);
	KSizPtr *insPtr(int i, void *p_);
	KSizPtr *delPtr(int i);
	void *getPtr(int i);
	int getInt(int i);
	KSizPtr *setPtr(int i, void *p_); // g܂܂Ȃ̂Œ.
	KSizPtr *setInt(int i, int j); // g܂܂Ȃ̂Œ.
	int sizPtr();
	int sizInt();
	KSizPtr *reserve0(int s0);
	int vprintf(const char *f, va_list arg);
	int printf(const char *f, ...);
	int addFile(const char *path, const char *mod, int flg);
	int inUseMem(int *pn = 0);
	static void *dest(KSizPtr *p);
	inline ~KSizPtr() { KSizPtr::dest(this); }
};

int KIndexS_search0(KSizPtr *sp, void *cmp_, void *opt, void *k, int *cr);
struct KIndexS {
	KSizPtr sp;
	void *cmp, *opt;
	inline KIndexS(KNoInit *ni) : sp((KNoInit *) 0) { (void) ni; }
	KIndexS(KMemPool *mp = kmemPool, void *cmp_ = 0, void *opt_ = 0, int s1 = 0);
	inline ~KIndexS() { }
	inline int search(void *k, int *cr) { return KIndexS_search0(&sp, cmp, opt, k, cr); }
	int ins(void *d);
	int del(void *k);
	inline void *add(void *d) { return sp.addPtr(d); }
	KIndexS *sort();
	int getN();
	void *getPtr(int i);
	int inUseMem(int *pn = 0);
	static void *dest(KIndexS *p);
};

struct KRestructurableRangeU32_Elmt {
	unsigned int s, p;
};
int KRestructurableRangeU32_cmp(KRestructurableRangeU32_Elmt *a, KRestructurableRangeU32_Elmt *b);
struct KRestructurableRangeU32;
struct KRestructurableRangeU32 {
	KIndexS idx;
//	void *(*palloc)(int, void *, void *, void *), (*pfree)(int, void *, void *), *opt;
	KRestructurableRangeU32(KMemPool *mp_ = kmemPool);
	inline KRestructurableRangeU32(KNoInit *ni) : idx((KNoInit *) 0) { (void) ni; }
	void add(unsigned int s, unsigned int p);
	void del(unsigned int s, unsigned int p);
	int test(unsigned int s, unsigned int p);
	unsigned int search(unsigned int s, unsigned int a);
	unsigned int total(int *pn = 0);
	KSizPtr *reportKsp(KSizPtr *sp);
	int inUseMem(int *pn = 0);
	static void *dest(KRestructurableRangeU32 *p);
};

void *KMemPool_allocSub(int s, KMemPool *mp);
extern int KMemPool_t[27 * 4];
//void *KMemPool_dest(KMemPool *p);
void *KMemPool0_alc(int s, void *o);
void KMemPool0_fre(int s, void *p, void *o);
struct KMemPool {
	void *p0;
	void *(*palc)(int, void *);
	void (*pfre)(int, void *, void *);
	int n, a1, a, da1, rn1;
	KPtrPool *pp;	// ܂32oCg.
	KRestructurableRangeU32 rr;	// 20oCg.
	KSizPtr sp;	// 12oCg. ܂64oCg.
	KMemPool(KMemPool *p0_, int a0 = -1, int da1 = 0, void *(*palc_)(int, void *) = KMemPool0_alc, void (*pfre_)(int, void *, void *) = KMemPool0_fre);
	inline KMemPool(KNoInit *ni) : rr((KNoInit *) 0), sp((KNoInit *) 0) { (void) ni; }
	int index(int s);
	void *alloc(int s);
	KMemPool *free(int s, void *q);
	void *realloc(int s0, int s1, void *q);
	KMemPool *report(void *fp);
	KPtrPool *ptrPool(int s);
	int s1(int s);
	void *calloc(int s);
	int inUseMem0(int *pn = 0);
	int inUse0(int *pn = 0);
	int inUse(int *pn = 0);
	static void *dest(KMemPool *p);
	inline ~KMemPool() { KMemPool::dest(this); }
};
struct KMemPool_static : KMemPool {
	static int readyCount;
	void ready();
	void end();
	inline KMemPool_static() : KMemPool((KNoInit *) 0) { ready(); }
	inline ~KMemPool_static() { a1 = 0; end(); }
};
extern KMemPool_static kmemPool0;

void *knopDest(void *p);
struct KAutoreleasePool;
extern KAutoreleasePool *kautoreleasePool;
struct KAutoreleaseNode {
	void *p, *f, *o; // o͂ȂC.
	int s;
};
struct KAutoreleasePool {
	KAutoreleasePool *prv;
	KMemPool *mp;
	KSizPtr sp;
	inline KAutoreleasePool(KNoInit *ni) : sp((KNoInit *) 0) { (void) ni; }
	KAutoreleasePool(KMemPool *mp_ = kmemPool);
	~KAutoreleasePool();
	KAutoreleasePool *add(int s, void *p, void *f = (void *) knopDest, void *opt = 0);
	int del(void *p, void **pf = 0, void **po = 0);
	int size(int *pn = 0);
	void *alloc(int s, void *f = (void *) knopDest, void *opt = 0);
	inline void *calloc(int s, void *f = (void *) knopDest, void *opt = 0);
	KAutoreleasePool *flush();
	int inUseMem(int *pn = 0);
	static void *dest(KAutoreleasePool *p);
};
struct KAutoreleasePool_static : KAutoreleasePool {
	void ready();
	KAutoreleasePool_static();
	~KAutoreleasePool_static();
};

void *kreadFileA(const char *path, const char *mod, int flg, int *psiz = 0, KAutoreleasePool *ap = kautoreleasePool);
void *ksgetsA(void *ps, int *psiz = 0, KAutoreleasePool *ap = kautoreleasePool);
char *kcutCrLfM(void *p, int s = -1);
char *kextractA(const char *p, int s = -1, KAutoreleasePool *ap = kautoreleasePool); // 𕔕Iɐ؂āAVK.

unsigned int kfnv32(void *p, int l);
unsigned long long kfnv64(void *p, int l);

struct KIndexHS;
struct KIndexHSNode {
	unsigned int h;
	void *d;
};
int KIndexHS_cmpEx(KIndexHSNode *a, KIndexHSNode *b, KIndexHS *w);
extern void *KIndexHS_optStatic;
extern int (*KIndexHS_cmpStatic)(const void *, const void *, void *);
int KIndexHS_cmpQsort(KIndexHSNode *a, KIndexHSNode *b);
int KIndexHS_search0(KSizPtr *sp, int (*cmp)(void *, void *, void *), void *opt, void *k, int *cr);
KSizPtr *KIndexHS_add0(KIndexHS *w, KIndexHSNode n);
struct KIndexHS {
	KSizPtr **p;
	int n, n1, r, n1r;
	void *hsh, *hshOpt;
	void *cmp, *cmpOpt;
	KMemPool *mp;
	KPtrPool *poolSP;
	inline KIndexHS(KNoInit *ni) { (void) ni; }
	KIndexHS(KMemPool *mp_, void *hsh_, void *hshOpt_, void *cmp_, void *cmpOpt_, int r_ = 8, int n1_ = 16);
	~KIndexHS();
	KIndexHS *reset();
	KIndexHS *rehash(int n1_);
	void *search(void *k);
	void *search(void *k, unsigned int h);
	KSizPtr *add(void *d);
	KIndexHS *sort();
	KIndexHS *ins(void *d);
	void *del(void *k);
	int collision(int *pmax = 0);
	static void *dest(KIndexHS *p);
};

struct KIndexDict0 : KIndexHS {	// KIndexDict0 : ofs=0, IuWFNg, Œ蒷.
	static int fHsh(void *k, int l);
	static int fCmp(void *a, void *b, int l);
	KIndexDict0(int l_, KMemPool *mp_ = kmemPool);
	static void *dest(KIndexDict0 *p);
};

struct KIndexDict3 : KIndexHS {	// KIndexDict3 : ofs=0, IuWFNgO, ϒ. (s, p)IuWFNgɂ.
	static int fHsh(int *k);
	static int fCmp(int *a, int *b);
	inline KIndexDict3(KNoInit *ni) : KIndexHS((KNoInit *) 0) { (void) ni; }
	KIndexDict3(KMemPool *mp_ = kmemPool);
};
struct KIndexDict3_static : KIndexDict3 {
	void ready();
	KIndexDict3_static();
	~KIndexDict3_static();
	static void *dest(KIndexDict3 *p);
};

#define NEW0(p, t) new(p->alloc(sizeof (t))) t
#define NEW1(p, t) new(p->alloc(sizeof (t), (void *) t :: dest)) t
#define NEW2(p, t, d) new(p->alloc(sizeof (t), (void *)) d) t

#endif
